import { Pbkdf2Sha512Factory, Pbkdf2Sha512Config, Pbkdf2sha512DigestSpec } from 'pbkdf2sha512';
import { OpgpService, OpgpProxyKey, Eventual } from 'opgp-service';
export interface Pbdkf2OpgpKeyFactoryBuilder {
    (opgp: OpgpService, config?: Partial<Pbdkf2OpgpKeyConfig>): Pbdkf2OpgpKeyFactory;
}
export interface Pbdkf2OpgpKeyConfig {
    size: number;
    locked: boolean;
    pbkdf2: Partial<Pbkdf2Sha512Config>;
    getkdf: Pbkdf2Sha512Factory;
}
export { Pbkdf2Sha512Factory, Pbkdf2Sha512Config, Pbkdf2sha512DigestSpec };
export interface Pbdkf2OpgpKeyFactory {
    (creds: Eventual<Credentials>): Promise<Pbkdf2OpgpKey>;
    (userOrArmor: Eventual<string> | Eventual<Pbkdf2OpgpKeyArmor>, passphrase: Eventual<string>): Promise<Pbkdf2OpgpKey>;
}
export interface Credentials {
    user: string;
    passphrase: string;
}
export interface Pbkdf2OpgpKey {
    key: OpgpProxyKey;
    pbkdf2: Pbkdf2sha512DigestSpec;
    unlock(passphrase: string): Promise<Pbkdf2OpgpKey>;
    toArmor(): Promise<Pbkdf2OpgpKeyArmor>;
    clone(): Promise<Pbkdf2OpgpKey>;
}
export interface Pbkdf2OpgpKeyArmor {
    armor: string;
    pbkdf2: Pbkdf2sha512DigestSpec;
}
declare const getPbkdf2OpgpKeyFactory: Pbdkf2OpgpKeyFactoryBuilder;
export default getPbkdf2OpgpKeyFactory;
